<?php
/*
Plugin Name: Flickr Photostream Widget
Plugin URI: http://bluecowhosting.com/blog/wordpress-plugins/flickr-photostream-widget/
Description: Rather than linking to the authors profile, this widget modifies the link to connect to the authors flickr photostream. This was designed for photoblogs that have multiple authors/photographers. 
If the shadowbox JS plugin is install the Flickr Photostream is rendered in a Lightbox, otherwise it will goto the flickr website. Uses the Yahoo IM account if in user profile, otherwise uses nickname. By Greg Royal/Bluecowhosting. Extends the Authors plugin from Gavriel Fleischer.

Version: 1.0
Author: Greg Royal/Blue Cow Hosting
Author URI: http://www.bluecowhosting.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

   Example,  my flickr name is kiwibloke
   The photo stream is http://www.flickr.com/photos/kiwibloke/show/
 
 */
// Multi-language support
if (defined('WPLANG') && function_exists('load_plugin_textdomain')) {
	load_plugin_textdomain('authors', PLUGINDIR.'/'.dirname(plugin_basename(__FILE__)).'/lang');
}

/* ***********************************************************
  Function: widget_flickr_authors_register
     
  This is the function called by the add_action(init) at the bottom and holds all the other functions: 
  
  widget_flickr_authors($args, $widget_args = 1) - main function that renders the HTML 
   
   widget_flickr_authors_style() - css settings 
   
   widget_flickr_authors_control() - renders in Widget admin 
   
  ***********************************************************/
function widget_flickr_authors_register() {

	if ( function_exists('register_sidebar_widget') ) :

    // *********************************************************************
    //   Function: widget_flickr_authors
    // *********************************************************************
    
    function widget_flickr_authors($args, $widget_args = 1) {

		extract($args, EXTR_SKIP);

		if ( is_numeric($widget_args) )
			$widget_args = array( 'number' => $widget_args );

		$widget_args = wp_parse_args( $widget_args, array( 'number' => -1 ) );
		extract($widget_args, EXTR_SKIP);

		$options = get_option('widget_flickr_authors');

       // set the title of the widget
		$title = empty($options[$number]['title']) ? __('FlickrStream','flickrstream') : 
		
		apply_filters('widget_title', $options[$number]['title']);
		$feedlink = $options[$number]['feedlink'] ? '1' : '0';
		$count = $options[$number]['count'] ? '1' : '0';
		$exclude_admin = $options[$number]['exclude_admin'] ? '1' : '0';

		?>
			<?php echo $before_widget; ?>
				<?php echo $before_title . $title . $after_title; ?>
				<ul>
					<?php
						$list_args = array('optioncount'=>$count, 'exclude_admin'=>$exclude_admin, 'show_fullname'=>0,  'echo'=>0, 'hide_empty'=>1);
						if ($feedlink) {
							$list_args['feed'] = 'RSS';
							$list_args['feed_image'] = '';
						}
						
						// Okay now I have to list them out one by one 
						$authors = wp_list_authors($list_args);  
						$flickr_url  = 'http://www.flickr.com/photos/';
						$p_url = substr( get_permalink(), 0,  strripos( get_permalink(), "/")  ); 
						
						$authors = explode('<li>', $authors);  
						foreach ($authors as $names) {  
						       // add in the shadowbox tag before the href tag
						       
						       if ( !($names  == '') ) { 
                                  $names = str_replace(' href=',' rel="shadowbox" href=', $names);
                                  $names = str_replace('Posts','Photostream', $names); 
                               
                                  // here is the tricky part replacing the URL 
                                  // http://www.flickr.com/photos/xxxxx/show/
                                  $pos1 = strpos( $names, "href="); 
                                  $pos1 = $pos1 + 6; 
                                  $pos2 = strpos( $names, '"', $pos1);
                                  $pos2 = $pos2 -1; 
                                  $temp_str = substr($names, $pos1, $pos2 - $pos1);
                             
                                   $pos3 = strrpos($temp_str, '/' );
							       $temp_user = substr($temp_str, $pos3 + 1); 
							       
							       $curauth = get_userdatabylogin( $temp_user );
							       
							       if  ( !(  $curauth->yim ==  ''  ) ) { 
							              $temp_user =  $curauth->yim;
							       } 
                                  $temp_str_2 = $flickr_url . $temp_user . '/show'; 
                                                                    
                                  $names = substr($names, 0, $pos1 ) . $temp_str_2 . substr($names, $pos2);  
                                  
								   echo '<li>' . $names  ;

								  
							    }
						} 
				
					?>
				</ul>
			<?php echo $after_widget; ?>
			
	<?php
	}
	

//  ***********************************************************
//   Function: widget_flickr_authors_style
//  ***********************************************************
	function widget_flickr_authors_style() {
		?>
        <style type="text/css">
        </style>
		<?php
	}

/*  ***********************************************************
   Function: widget_flickr_authors_control

     This is the function that manages the widget control in admin
     
  *********************************************************** */

	function widget_flickr_authors_control( $widget_args ) {
		global $wp_registered_widgets;
		static $updated = false;

		if ( is_numeric($widget_args) )
			$widget_args = array( 'number' => $widget_args );
			
		$widget_args = wp_parse_args( $widget_args, array( 'number' => -1 ) );
		extract($widget_args, EXTR_SKIP);

        // options for this widget
		$options = get_option('widget_flickr_authors');

        // if not found then create empty array
		if ( !is_array( $options ) )
			$options = array();

        // if not updated and not empty POST
        if ( !$updated && !empty($_POST['sidebar']) ) {
        
            // get the variable from POST Variable sidebar 
			$sidebar = (string) $_POST['sidebar'];
			
			$sidebars_widgets = wp_get_sidebars_widgets();
			
			if ( isset($sidebars_widgets[$sidebar]) )
				$this_sidebar =& $sidebars_widgets[$sidebar];
			else
				$this_sidebar = array();

			foreach ( (array) $this_sidebar as $_widget_id ) {
				if ( 'widget_flickr_authors' == $wp_registered_widgets[$_widget_id]['callback'] && isset($wp_registered_widgets[$_widget_id]['params'][0]['number']) ) {
					$widget_number = $wp_registered_widgets[$_widget_id]['params'][0]['number'];
					if ( !in_array( "fauthors-$widget_number", $_POST['widget-id'] ) ) // the widget has been removed.
						unset($options[$widget_number]);
				}
			}

           // here is where we update from the POST 
           foreach ( (array) $_POST['widget-flickr-authors'] as $widget_number => $widget_flickr_authors ) {
				if ( !isset($widget_flickr_authors['title']) && isset($options[$widget_number]) ) // user clicked cancel
					continue;
				$title = trim(strip_tags(stripslashes($widget_flickr_authors['title'])));
				$feedlink = isset($widget_flickr_authors['feedlink']);
				$count = isset($widget_flickr_authors['count']);
				$exclude_admin = isset($widget_flickr_authors['exclude_admin']);
				$options[$widget_number] = compact( 'title', 'feedlink', 'count', 'exclude_admin' );
			}

			update_option('widget_flickr_authors', $options);
			$updated = true;
		}

		if ( -1 == $number ) {
			$title = '';
			$feedlink = false;
			$count = false;
			$exclude_admin = 0;
			$number = '%i%';
		} else {
			$title = attribute_escape( $options[$number]['title'] );
			$feedlink = (bool) $options[$number]['feedlink'];
			$count = (bool) $options[$number]['count'];
			$exclude_admin = (bool) $options[$number]['exclude_admin'];
		}

		?>
		
		<p><label for="authors-title-<?php echo $number; ?>"><?php _e('Title','authors'); ?>: <input id="fauthors-title-<?php echo $number; ?>" name="widget-flickr-authors[<?php echo $number; ?>][title]" type="text" value="<?php echo $title; ?>" class="widefat" /></label></p>
		
		<p><label for="authors-feedlink-<?php echo $number; ?>"><input id="fauthors-feedlink-<?php echo $number; ?>" name="widget-flickr-authors[<?php echo $number; ?>][feedlink]" type="checkbox" <?php checked( $feedlink, true ); ?> class="checkbox" /> <?php _e('Show RSS links','authors'); ?></label></p>
		
		<p><label for="fauthors-count-<?php echo $number; ?>"><input id="fauthors-count-<?php echo $number; ?>" name="widget-flickr-authors[<?php echo $number; ?>][count]" type="checkbox" <?php checked( $count, true ); ?> class="checkbox" /> <?php _e('Show post counts','fauthors'); ?></label></p>
		
		<p><label for="fauthors-exclude-admin-<?php echo $number; ?>"><input id="fauthors-exclude-admin-<?php echo $number; ?>" name="widget-flickr-authors[<?php echo $number; ?>][exclude_admin]" type="checkbox" <?php checked( $exclude_admin, true ); ?> class="checkbox" /> <?php _e('Exclude admin','authors'); ?></label></p>
		<input type="hidden" name="widget-flickr-authors[<?php echo $number; ?>][submit]" value="1" />
		
	<?php
	}

//  ***********************************************************
//   Function: widget_flickr_authors_upgrade
//  ***********************************************************
	function widget_flickr_authors_upgrade() {
		$options = get_option( 'widget_flickr_authors' );

		if ( !isset( $options['title'] ) )
			return $options;

		$newoptions = array( 1 => $options );

		update_option( 'widget_flickr_authors', $newoptions );

		$sidebars_widgets = get_option( 'sidebars_widgets' );
		
		if ( is_array( $sidebars_widgets ) ) {
			foreach ( $sidebars_widgets as $sidebar => $widgets ) {
				if ( is_array( $widgets ) ) {
					foreach ( $widgets as $widget )
						$new_widgets[$sidebar][] = ( $widget == 'flickrstream' ) ? 'fauthors-1' : $widget;
				} else {
					$new_widgets[$sidebar] = $widgets;
				}
			}
			if ( $new_widgets != $sidebars_widgets )
				update_option( 'sidebars_widgets', $new_widgets );
			}

		return $newoptions;
	}  // ================ end of upgrade ===

    // if the options is empty then get the options for this widget otherwise create blank $options array
    if ( !$options = get_option( 'widget_flickr_authors' ) )
		$options = array();

    // if title is set then run upgrade 
	if ( isset($options['title']) )
		$options = widget_flickr_authors_upgrade();

    // build widget ops array 
	$widget_ops = array( 'classname' => 'widget_flickr_authors', 'description' => __( 'A list of the flickr streams','flickrstream' ) );

    // Display name of widget in dashboard 
	$name = __( 'Flickrstream','flickrstream' );

    // set ID to false, this is the widget id we are going to use
	$id = false;
	
	foreach ( (array) array_keys($options) as $o ) {
		// Old widgets can have null values for some reason
		if ( !isset($options[$o]['title']) )
			continue;
			
		$id = "flickrstream-$o";
		
		// unique slug, name of widget in dashboard, output callback, render array, $wp_dashboard_empty_callback 
		wp_register_sidebar_widget( $id, $name, 'widget_flickr_authors', $widget_ops, array( 'number' => $o ) );
		
		// tells wordpress how to render admin control 
		wp_register_widget_control( $id, $name, 'widget_flickr_authors_control', array( 'id_base' => 'flickrstream' ), array( 'number' => $o ) );
	}

	// If there are none, we register the widget's existance with a generic template
	if ( !$id ) {
	
	    // unique slug, name of widget in dashboard, output callback, render array, $wp_dashboard_empty_callback 
		wp_register_sidebar_widget( 'flickrstream-1', $name, 'widget_flickr_authors', $widget_ops, array( 'number' => -1 ) );
		
		// tells wordpress how to render admin control 
		// unique slug, description, calback function, 
		wp_register_widget_control( 'flickrstream-1', $name, 'widget_flickr_authors_control', array( 'id_base' => 'flickrstream' ), array( 'number' => -1 ) );
	}
	endif;
}

add_action('init', 'widget_flickr_authors_register');

?>